Subject: bug#26201: hydra.gnu.org uses ‘guix publish’ for nars and narinfos

From: Tobias Geerinckx-Rice <[email-masked]>
Date: Thu, 23 Mar 2017 20:25:44 +0100

Ludo',

On 22/03/17 23:06, Ludovic Courtès wrote:
> Tobias Geerinckx-Rice <[email-masked]> skribis:
>>       proxy_cache_lock          on;
>>       proxy_cache_lock_timeout  3h; #yolo
>>       proxy_cache_use_stale     error timeout
>>                                 http_500 http_502 http_503 http_504;
> I didn’t fully understand the docs for the last 3 directives here.  For
> instance, what happens when 10 clients do GET /nar/xyz-texlive?  Do the
> 9 unlucky clients wait for 3 hours and then get 404?

From ‘proxy_cache_lock’ [1]:

  “When enabled, only one request at a time will be allowed to populate
   a new cache element identified according to the proxy_cache_key
   directive by passing a request to a proxied server. Other requests
   of the same cache element will either wait for a response to appear
   in the cache or the cache lock for this element to be released, up
   to the time set by the proxy_cache_lock_timeout directive.”

Hmm. Good point: ‘to appear in the cache’, when we don't cache 404s or
even 410s.

I don't actually know.

Kind regards,

T G-R

[1]:
https://nginx.org/en/docs/http/ngx_http_proxy_module.html#proxy_cache_lock